import socket

from charms.reactive import RelationBase
from charms.reactive import hook
from charms.reactive import scopes

from charmhelpers.core import hookenv


class SlurmRequires(RelationBase):
    scope = scopes.GLOBAL

    node_info = {
        'hostname': socket.gethostname(),
        'partition': hookenv.config('partition'),
    }

    @hook('{requires:slurm-cluster}-relation-{joined,changed}')
    def joined_or_changed(self):
        self.set_state('{relation_name}.connected')
        if self.get_config():
            self.set_state('{relation_name}.available')
        else:
            self.remove_state('{relation_name}.available')

    @hook('{requires:slurm-cluster}-relation-{departed,broken}')
    def departed(self):
        self.remove_state('{relation_name}.connected')
        self.remove_state('{relation_name}.available')

    def set_node_info(self):
        self.set_remote(**self.node_info)

    def get_config(self):
        config = self.get_remote('config')
        return eval(config) if config else False
